#!/usr/bin/python
# -*- coding: iso-8859-1 -*-

# Mattricks, a free helper program for hattricks players.
# Copyright (C) 2003 Mattricks Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys, string
from Mattricks import TeamSelector, HRFData, Terms

def command_line_main():
    h1 = HRFData.HRFData(sys.argv[1])
    ts = TeamSelector.TeamSelector(h1)
    pt = ts.get_player_table()
    lineup = ts.select_team()

    for f, plist in pt.items():
        print
        print f.capitalize() + ":"
        print
        for val, pid in plist[:8]:
            print "%5.2f %s" % (val, h1.get_player(pid).name)

    print "\nTeam:\n"
    for descr, cpos, pos in TeamSelector.TeamSelector.lineup_info:
        print "%s %s %d %.2f %s" % (
            string.ljust(descr, 13),
            string.ljust(Terms.individual_order[lineup[cpos][4]] + ":", 16),
            lineup[cpos][2],
            lineup[cpos][1],
            h1.get_player(lineup[cpos][0], True).name)

    print "\n%s   %.2f" % (string.ljust("Teamval:", 30),
                           ts.de.teamval(lineup))

if __name__ == "__main__":
    command_line_main()
