# -*- coding: iso-8859-1 -*-

# Mattricks, a free helper program for hattricks players.
# Copyright (C) 2003 Mattricks Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from wxPython.wx import *

ID_ABOUT = 101
ID_EXIT  = 102
REMOVE_COLUMNS = 103
ADD_COLUMNS = 104

class ColumnList(wxListBox):
    def __init__(self, parent, items):
        wxListBox.__init__(self, parent, -1, style=wxLB_EXTENDED)
        self.InsertItems(items, 0)

class ColumnDialog(wxDialog):
    def __init__(self, enabledstrings, disabledstrings):
        wxDialog.__init__(self, NULL, -1, "Kolumneditor", wxDefaultPosition, wxSize(500, 400))
        self.topboxsize = wxBoxSizer(wxVERTICAL)
        self.boxsize = wxBoxSizer(wxHORIZONTAL)
        self.removedcolumns = ColumnList(self, disabledstrings)
        self.addcolumns = ColumnList(self, enabledstrings)
        self.boxsize.Add(self.removedcolumns)
        self.transferbuttonsize = wxBoxSizer(wxVERTICAL)
        self.removebutton = wxButton(self, REMOVE_COLUMNS, "<<")
        self.transferbuttonsize.Add(self.removebutton)
        self.transferbuttonsize.Add(wxButton(self, ADD_COLUMNS, ">>"))
        self.boxsize.Add(self.transferbuttonsize)
        self.boxsize.Add(self.addcolumns)
        self.buttonsize = wxBoxSizer(wxHORIZONTAL)
        self.topboxsize.Add(self.boxsize)
        self.buttonsize.Add(wxButton(self, wxID_OK, "OK"))
        self.buttonsize.Add(wxButton(self, wxID_CANCEL, "Cancel"))
        self.topboxsize.Add(self.buttonsize)
        self.SetSizer(self.topboxsize)
        self.topboxsize.SetSizeHints(self)
        EVT_BUTTON(self, REMOVE_COLUMNS, self.OnRemoveColumns)
        EVT_BUTTON(self, ADD_COLUMNS, self.OnAddColumns)

    def OnRemoveColumns(self, event):
        print "Remove columns"
        self.MoveColumns(self.addcolumns, self.removedcolumns)
        
    def OnAddColumns(self, event):
        print "Add columns"
        self.MoveColumns(self.removedcolumns, self.addcolumns)

    def MoveColumns(self, srccolumns, dstcolumns):
        self.mytuple = srccolumns.GetSelections()
        y = 0
        for x in range(len(self.mytuple)):
            dstcolumns.Append(srccolumns.GetString(self.mytuple[x] - y))
            srccolumns.Delete(self.mytuple[x] - y)
            y += 1

    def GetEnabledStrings(self):
        return self.GetStrings(self.addcolumns)

    def GetDisabledStrings(self):
        return self.GetStrings(self.removedcolumns)

    def GetStrings(self, columns):
        list = []
        for x in range(columns.GetCount()):
            list = list + [columns.GetString(x)]
        return list        
