# -*- coding: iso-8859-1 -*-

# Mattricks, a free helper program for hattricks players.
# Copyright (C) 2003 Mattricks Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import DataInfo

from Common import *
from Commonwx import *

from wxPython.wx import *
from math import *

heading_list = ["Ekonom", "Inkomst", "Kostnad", "Vinst", "Veckor"]
weekly_cost = 15000

class EconomyDialog(wxDialog):


    def __init__(self, parent, money, economists_now, leagueid):

        pos = wxDefaultPosition
        size = wxDefaultSize,
        style = wxDEFAULT_DIALOG_STYLE

        wxDialog.__init__(self, parent, -1, "Ekonomer", pos, wxSize(500, 400), style, "EconomyDialog")

        sizer = wxBoxSizer(wxVERTICAL)

        (dummy, dummy, currency,
         currency_is_prefix, currency_exchangerate, dummy) = DataInfo.country_info[leagueid]

        # Ok / Cancel buttons

        fgs=wxFlexGridSizer(cols=5, vgap=5, hgap=10)
        for text in heading_list:
            fgs.Add(wxStaticText(self,-1,text))

        best = -1
        last = -1
        for eco in range(10):
            fgs.Add(wxStaticText(self,-1,str(eco+1)))
            income=int(self.GetEconomyIncome(money, eco+1)-self.GetEconomyIncome(money, eco))
            fgs.Add(wxStaticText(self, -1,
                                 add_currency_to_money(income, currency, currency_is_prefix)),
                    0, wxALIGN_RIGHT)
            fgs.Add(wxStaticText(self,-1,add_currency_to_money(weekly_cost, currency,
                                                               currency_is_prefix)),
                    0, wxALIGN_RIGHT)
            profit = int(income-weekly_cost)
            profittext=wxStaticText(self,-1,add_currency_to_money(profit, currency,
                                                                  currency_is_prefix, True))
            fgs.Add(profittext, 0, wxALIGN_RIGHT)
            SetTextColour(profittext,profit)
            if profit>0:
                weeks=str(int(weekly_cost/profit))
            else:
                weeks=""
            fgs.Add(wxStaticText(self,-1,weeks), 0, wxALIGN_RIGHT)
            if profit > weekly_cost:
                best = eco

            if profit <= 0:
                break
            else:
                last = eco

        text=wxStaticText(self,-1,"Det verkar vara bst med " + str(best+1) + " ekonomer fr dig.")
        sizer.Add(text, 0,wxALL, 5)
        if last != best:
            text=wxStaticText(self,-1,"Om du sparar p lngre sikt kan dock upp till " + str(last+1) + " ekonomer vara bst.")
            sizer.Add(text, 0,wxALL, 5)

        text=wxStaticText(self,-1,"Du har just nu " + str(economists_now) + " ekonomer anstllda.")
        sizer.Add(text, 0,wxALL, 5)

        sizer.Add(fgs, 0, wxALIGN_CENTER | wxALL, 10)

        text=wxStaticText(self,-1,"Detta r en experimentell funktion. Jmfr grna med\nhttp://kilnovur.sytes.net/ht-tools/ekonomer/ekonomer.html")
        sizer.Add(text, 0,wxALL, 5)

        button = wxButton(self, wxID_OK, "OK")
        button.SetDefault()

        sizer.Add(button, 0, wxALIGN_RIGHT | wxALL, 10)

        self.SetSizer(sizer)
        self.SetAutoLayout(True)
        sizer.Fit(self)

        EVT_BUTTON(self, wxID_OK, self.OnOK)


    def OnOK(self, event):
            self.EndModal(wxID_OK)

    def GetEconomyIncome(self, money, economists):
        if money > 0:
            ret=1000*floor(money*(0.003*sqrt(economists)/1000))
        else:
            ret=1000*floor(-money*(0.005*sqrt(economists)/1000))
        if ret > 1000000:
            ret=1000000
        return ret
