# -*- coding: iso-8859-1 -*-

# Mattricks, a free helper program for hattricks players.
# Copyright (C) 2003 Mattricks Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import urllib
import os.path
import re
import string
import sys
import time

FETCH_ERROR_STRANGE_RESPONSE = 1
FETCH_ERROR_LOGIN_ERROR = 2

def make_hrf_filename(path):
    def make_real_path(path, amount_numbers):
        filename = string.join(["%04d", "-%02d", "-%02d", \
                                "_%02d", "-%02d", "-%02d"][:amount_numbers], "") % \
                                time.localtime(time.time())[:amount_numbers] + ".hrf"
        return os.path.realpath(os.path.join(os.path.expanduser(path), filename))

    filename = make_real_path(path, 3)
    if os.path.exists(filename):
        filename = make_real_path(path, 6)
    return filename

def fetch_hrf(loginname, password, path = "", dlg=None, filename=None):
    # ppna login-sidan, med loginnamn och lsenord.
    u = urllib.urlopen("http://195.149.159.155/Common/default.asp", \
                       urllib.urlencode([("loginname", loginname), ("password", password), \
                                         ("action", "login"), ("submit", "Log on")]))

    if dlg != None:
        dlg.Update(1)

    # Se till att lagra kakan
    try:
        cookie = u.info()['set-cookie']
        cookie = cookie[:string.find(cookie, ";")]
    except:
        print "Couldn't get cookie"
        sys.exit(0)

    if filename == None:
        filename = make_hrf_filename(path)

    regexp = re.compile("loginError=(Yes|)&", re.IGNORECASE)
    pwdata = u.read()
    result = regexp.search(pwdata)
    if not result:
        print pwdata
        return FETCH_ERROR_STRANGE_RESPONSE
    if len(result.group(1)) > 0:
        print pwdata
        return FETCH_ERROR_LOGIN_ERROR

    if dlg != None:
        dlg.Update(2)

    o = urllib.FancyURLopener()

    if dlg != None:
        dlg.Update(5, "Downloading HRF-file...")

    o.addheader("Cookie", cookie)
    u = o.retrieve("http://195.149.159.155/Common/hrf.asp", filename)

    if dlg != None:
        dlg.Update(9, "Updating tables...")

    return filename
