# -*- coding: iso-8859-1 -*-

# Mattricks, a free helper program for hattricks players.
# Copyright (C) 2003 Mattricks Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os.path

from wxPython.wx import *

wxInitAllImageHandlers()

class ImageStorage:
    def __init__(self, search_path):
        self.search_path = [os.path.abspath(p) for p in search_path.split(':')]
        self.images = {}

    def get_bitmap_from_file(self, rel_path):
        rel_path = os.path.normpath(rel_path)
        if self.images.has_key(rel_path):
            return self.images[rel_path]

        bmp = None
        for p in self.search_path:
            file = os.path.join(p, rel_path)
            #print file
            if os.path.exists(file):
                img = wxImage(file, wxBITMAP_TYPE_PNG)
                if img.Ok():
                    bmp = img.ConvertToBitmap()
                    break
        if bmp == None:
            bmp = wxEmptyImage(1,1)
        self.images[rel_path] = bmp
        return bmp

datapath = "Data:/usr/share/Mattricks:/usr/local/share/Mattricks"
Images = ImageStorage(datapath)
