# -*- coding: iso-8859-1 -*-

# Mattricks, a free helper program for hattricks players.
# Copyright (C) 2003 Mattricks Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import DataInfo
import HRFData
import Terms

from wxPython.wx import *
from Common import *
from Commonwx import *
from Images import Images

abilities=[
#    'ska',
#    'warnings',
    'for',
    'CountryID',
    'speciality']

economy=[
    'mkt',
    'sal']

personality=[
    'ald',
    'rut',
    'gentleness',
    'Aggressiveness',
    'honesty',
    'led']

playerabilities=[
    'uth',
    'mlv',
    'spe',
    'fra',
    'ytt',
    'bac',
    'mal',
    'fas']

goals = [
    'gev',
    'hat',
    'gtl',
    'gtc',
    'gtt']

class PlayerDialog(wxDialog):
    
    def __init__(self, parent, htdata, player_id):
        
        pos = wxDefaultPosition
        size = wxDefaultSize,
        style = wxDEFAULT_DIALOG_STYLE

        wxDialog.__init__(self, parent, -1, htdata.get_player(player_id,True).name, pos, wxSize(500, 400), style, htdata.get_player(player_id,True).name)

        totsizer=wxBoxSizer(wxVERTICAL)
        sizer = wxBoxSizer(wxVERTICAL)
        namesizer = wxBoxSizer(wxHORIZONTAL)
        
        nametext=wxStaticText(self,-1,htdata.get_player(player_id,True).name + " (" + str(player_id) + ")")
        SetTextFace(nametext, FACE_BOLD | FACE_BIG)
        namesizer.Add(nametext, 0, wxALL,5)

        yellows=htdata.get_player(player_id).warnings
        if yellows > 0:
            if yellows == 3:
                img = Images.get_bitmap_from_file("redcard.png")
            elif yellows == 2:
                img =  Images.get_bitmap_from_file("2yellowcards.png")
            else:
                img =  Images.get_bitmap_from_file("yellowcard.png")
            namesizer.Add(wxStaticBitmap(self,-1,img),0,wxALL|wxALIGN_CENTER_VERTICAL ,2)
      
        injury=htdata.get_player(player_id).ska
        if injury == 0:
            namesizer.Add(wxStaticText(self,-1,"Plster"))
        elif injury > 0:
            iimg =  Images.get_bitmap_from_file("injury.png")
            namesizer.Add(wxStaticBitmap(self,-1,iimg),0,wxALL|wxALIGN_CENTER_VERTICAL ,2)
            namesizer.Add(wxStaticText(self,-1,str(injury)),0,wxALL|wxALIGN_CENTER_VERTICAL ,1)

        sizer.AddSizer(namesizer, 0, wxALL, 5)

        if htdata != None:
            fgs=wxFlexGridSizer(cols=2, vgap=5, hgap=10)
            for text in abilities:
                if text == None:
                    fgs.Add(15,15)
                    fgs.Add(15,15)
                else:
                    value = getattr(htdata.get_player(player_id),text)
                    if value > 0:
                        fgs.Add(wxStaticText(self,-1,DataInfo.known_player_data_info[text][1]))
                        flagname=None
                        if text=='CountryID':
                            CID=Terms.country[value]
                            flagname=DataInfo.country_info[CID][5]
                        if flagname == None:
                            fgs.Add(wxStaticText(self,-1,getattr(htdata.get_player(player_id,True),text)))
                        else:
                            fgs.Add(wxStaticBitmap(self,-1,Images.get_bitmap_from_file(flagname)))
            sizer.AddSizer(fgs, 0, wxALL | wxEXPAND, 5)
            
        economysizer_box=wxStaticBox(self,-1, "Ekonomi")
        economysizer = wxStaticBoxSizer(economysizer_box, wxHORIZONTAL)

        if htdata != None:
            fgs=wxFlexGridSizer(cols=4, vgap=5, hgap=10)
            for text in economy:
                fgs.Add(wxStaticText(self,-1,DataInfo.known_player_data_info[text][1]))
                fgs.Add(wxStaticText(self,-1,getattr(htdata.get_player(player_id,True),text)))
                
            economysizer.AddSizer(fgs, 1, wxALL |wxEXPAND, 5)

        sizer.AddSizer(economysizer, 0, wxALIGN_LEFT | wxALL | wxEXPAND, 5)

        personalitysizer_box=wxStaticBox(self,-1, "Personlighet")
        personalitysizer = wxStaticBoxSizer(personalitysizer_box, wxHORIZONTAL)

        if htdata != None:
            fgs=wxFlexGridSizer(cols=4, vgap=5, hgap=10)
            for text in personality:
                fgs.Add(wxStaticText(self,-1,DataInfo.known_player_data_info[text][1]))
                fgs.Add(wxStaticText(self,-1,getattr(htdata.get_player(player_id,True),text)))
                
            personalitysizer.AddSizer(fgs, 1, wxALL |wxEXPAND, 5)

        sizer.AddSizer(personalitysizer, 0, wxALIGN_LEFT | wxALL | wxEXPAND, 5)

        playersizer_box=wxStaticBox(self,-1, "Frmgor")
        playersizer = wxStaticBoxSizer(playersizer_box, wxHORIZONTAL)

        if htdata != None:
            fgs=wxFlexGridSizer(cols=4, vgap=5, hgap=10)
            for text in playerabilities:
                fgs.Add(wxStaticText(self,-1,DataInfo.known_player_data_info[text][1]))
                fgs.Add(wxStaticText(self,-1,getattr(htdata.get_player(player_id,True),text)))
                
            playersizer.AddSizer(fgs, 1, wxALL |wxEXPAND, 5)

        sizer.AddSizer(playersizer, 0, wxALIGN_LEFT | wxALL | wxEXPAND, 5)

        goalsizer_box=wxStaticBox(self,-1, "Antal ml")
        goalsizer = wxStaticBoxSizer(goalsizer_box, wxVERTICAL)

        if htdata != None:
            fgs=wxFlexGridSizer(cols=2, vgap=5, hgap=10)
            for text in goals:
                fgs.Add(wxStaticText(self,-1,DataInfo.known_player_data_info[text][1]))
                fgs.Add(wxStaticText(self,-1,getattr(htdata.get_player(player_id,True),text)))
                
            goalsizer.AddSizer(fgs, 0, wxALIGN_CENTER | wxALL, 5)

        hsizer=wxBoxSizer(wxHORIZONTAL)
        hsizer.AddSizer(sizer, 0, wxALIGN_LEFT | wxALIGN_BOTTOM| wxALL, 5)
        hsizer.AddSizer(goalsizer, 0, wxALIGN_BOTTOM | wxALL, 5)

        totsizer.AddSizer(hsizer, 0, wxALL, 5)
        # Ok / Cancel buttons

        button = wxButton(self, wxID_OK, "OK")
        button.SetDefault()

        totsizer.Add(button, 0, wxALIGN_RIGHT | wxALL, 10)

        self.SetSizer(totsizer)
        self.SetAutoLayout(True)
        totsizer.Fit(self)
